<?xml version="1.0" encoding="UTF-8"?>
<jube>
  <include-path>
  <path tag="leonardo">platforms/leonardo</path>
  <path tag="si-quantum-dot">workloads/siesta/si-quantum-dot</path>
  </include-path>

  <benchmark name="Leonardo GPU ON/OFF benchmark" outpath="bench-leonardo">
    <comment>benchmark POC in Leonardo</comment>    

    <parameterset name="systemParameter" init_with="platform.xml">
    <!-- no. of nodes, tasks, etc -->
    <parameter name="taskspernode" type="int" default="4">32</parameter>
    <parameter name="threadspertask" type="int">1</parameter>
    <!--  -->
    <parameter name="executable">siesta</parameter>
    <parameter name="accountno" >Max3_devel_2</parameter>
    <parameter name="args_executable"> $fin > $fout </parameter>
    <parameter name="timelimit">00:59:00</parameter>
    </parameterset>

   <!-- running the job, llsubmit, runjob , etc -->
    <parameterset name="executeset" init_with="platform.xml">
    <parameter name="ready_file">ready</parameter>
    <!-- Several versions can be specified here, separated by commas, as usual -->
    <parameter name="modules">module use /leonardo/pub/userexternal/agarcia0/usermodules/Core; module load  siesta-max/1.X-profile</parameter>
    </parameterset>

    <!-- testcase parameters -->
    <parameterset name="testcaseset" init_with="workload.xml">
      <parameter name="supercell_3">1,2</parameter>
      <parameter name="gpu_flag">0,1</parameter>
    </parameterset>

    <!-- files needed incl job file and input files -->
    <fileset name="jobfiles" init_with="platform.xml">
      <copy>$jube_benchmark_home/workloads/siesta/$dirin/*</copy>
    </fileset>

    <!-- Substitute jobfile -->
    <substituteset name="executesub" init_with="platform.xml">
    <sub source="#ACCOUNT_NO#" dest="$accountno" />
    <sub source="#PREPROCESS#" dest="$modules" />
    <sub source="#MINMEM#" dest="$minmem" />
    <sub source="#READY#" dest="$ready_file" />
    </substituteset>

    <!-- pre-processed fdf file 
    <fileset name="fdffiles" init_with="workload.xml">
    </fileset> -->
    <!-- testcase fdf options -->
    <substituteset name="fdfsub" init_with="workload.xml">
    </substituteset>

    <!-- Operation -->
    <step name="submit"  >
      <use>testcaseset</use>
      <use>systemParameter</use>
      <use>executeset</use>
      <use>jobfiles</use>
      <use>executesub</use>
      <use>fdfsub</use>
      <do>$submit $submit_script</do> <!-- actual submission directive -->
    </step>    

    <patternset name="pattern">
       <pattern name="walltime" type="float"></pattern>
    </patternset>

    <analyser name="analyse">
      <use>pattern</use>
      <analyse step="submit">
        <file>$fout</file>
      </analyse>
    </analyser>

    <result>
      <use>analyse</use>
      <table name="result" style="pretty" sort="nodes" tag="!csv">
        <column title="Nodes">nodes</column>
        <column title="Tasks/Node">taskspernode</column>
        <column title="Threads/Task">threadspertask</column>
        <column format=".2f" title="walltime">walltime</column>
      </table>
   </result>
  </benchmark>
</jube>
